## rna-star 2.7.3a+dfsg

=== source/Makefile ===
# user may define these whole flags
# LDFLAGS
# CPPFLAGS
# CXXFLAGS
# CFLAGS

# or these user-set flags that will be added to standard flags
LDFLAGSextra ?=
CXXFLAGSextra ?=

# user may define the compiler
CXX ?= g++

# pre-defined flags
LDFLAGS_shared := -pthread -Lhtslib -Bstatic -lhts -Bdynamic -lz
LDFLAGS_static := -static -static-libgcc -pthread -Lhtslib -lhts -lz 
LDFLAGS_Mac :=-pthread -lz htslib/libhts.a
LDFLAGS_Mac_static :=-pthread -lz -static-libgcc htslib/libhts.a
LDFLAGS_gdb := $(LDFLAGS_shared)

COMPTIMEPLACE := -D'COMPILATION_TIME_PLACE="$(shell echo `date` $(HOSTNAME):`pwd`)"'

CXXFLAGS_common := -pipe -std=c++11 -Wall -Wextra -fopenmp $(COMPTIMEPLACE)
CXXFLAGS_main := -O3 $(CXXFLAGS_common)
CXXFLAGS_gdb :=  -O0 -g $(CXXFLAGS_common)

CFLAGS := -O3 -pipe -Wall -Wextra $(CFLAGS)


##########################################################################################################

OBJECTS = SoloFeature_sumThreads.o SoloFeature_countVelocyto.o SoloFeature_countCBgeneUMI.o Transcriptome_classifyAlign.o SoloFeature_cellFiltering.o \
        SoloFeature_statsOutput.o bamSortByCoordinate.o SoloBarcode.o \
        ParametersSolo.o SoloRead.o SoloRead_record.o \
	SoloReadBarcode.o SoloReadBarcode_getCBandUMI.o SoloBarcode_extractBarcode.o \
	SoloReadFeature.o SoloReadFeature_record.o SoloReadFeature_inputRecords.o \
	Solo.o SoloFeature.o SoloFeature_collapseUMI.o SoloFeature_outputResults.o SoloFeature_processRecords.o SoloFeature_addBAMtags.o \
	ReadAlign_outputAlignments.o  \
	ReadAlign.o STAR.o \
	SharedMemory.o PackedArray.o SuffixArrayFuns.o Parameters.o InOutStreams.o SequenceFuns.o Genome.o Stats.o \
	Transcript.o Transcript_alignScore.o Transcript_generateCigarP.o Chain.o \
	Transcript_variationAdjust.o Variation.o ReadAlign_waspMap.o \
	ReadAlign_storeAligns.o ReadAlign_stitchPieces.o ReadAlign_multMapSelect.o ReadAlign_mapOneRead.o readLoad.o \
	ReadAlignChunk.o ReadAlignChunk_processChunks.o ReadAlignChunk_mapChunk.o \
	OutSJ.o outputSJ.o blocksOverlap.o ThreadControl.o sysRemoveDir.o \
	ReadAlign_maxMappableLength2strands.o binarySearch2.o\
	ReadAlign_outputTranscriptSAM.o ReadAlign_outputTranscriptSJ.o ReadAlign_outputTranscriptCIGARp.o ReadAlign_calcCIGAR.cpp \
	ReadAlign_createExtendWindowsWithAlign.o ReadAlign_assignAlignToWindow.o ReadAlign_oneRead.o \
	ReadAlign_stitchWindowSeeds.o \
	ReadAlign_peOverlapMergeMap.o ReadAlign_mappedFilter.o \
	ParametersChimeric_initialize.o ReadAlign_chimericDetection.o ReadAlign_chimericDetectionOld.o ReadAlign_chimericDetectionOldOutput.o\
	ChimericDetection.o ChimericDetection_chimericDetectionMult.o ReadAlign_chimericDetectionPEmerged.o \
	ChimericSegment.cpp ChimericAlign.cpp ChimericAlign_chimericJunctionOutput.o ChimericAlign_chimericStitching.o \
	stitchWindowAligns.o extendAlign.o stitchAlignToTranscript.o alignSmithWaterman.o \
	Genome_genomeGenerate.o genomeParametersWrite.o genomeScanFastaFiles.o genomeSAindex.o \
	Genome_insertSequences.o insertSeqSA.o funCompareUintAndSuffixes.o funCompareUintAndSuffixesMemcmp.o \
	TimeFunctions.o ErrorWarning.o loadGTF.o streamFuns.o stringSubstituteAll.o \
	Transcriptome.o Transcriptome_quantAlign.o Transcriptome_geneFullAlignOverlap.o \
	ReadAlign_quantTranscriptome.o Quantifications.o Transcriptome_geneCountsAddAlign.o \
	sjdbLoadFromFiles.o sjdbLoadFromStream.o sjdbPrepare.o sjdbBuildIndex.o sjdbInsertJunctions.o mapThreadsSpawn.o \
	Parameters_openReadsFiles.cpp Parameters_closeReadsFiles.cpp Parameters_readSAMheader.o \
	bam_cat.o serviceFuns.o GlobalVariables.cpp \
	BAMoutput.o BAMfunctions.o ReadAlign_alignBAM.o BAMbinSortByCoordinate.o signalFromBAM.o bamRemoveDuplicates.o BAMbinSortUnmapped.o 

SOURCES := $(wildcard *.cpp) $(wildcard *.c)


%.o : %.cpp
	$(CXX) -c $(CPPFLAGS) $(CXXFLAGS) $<

%.o : %.c
	$(CXX) -c $(CPPFLAGS) $(CFLAGS) $<

all: STAR

.PHONY: clean
clean:
	rm -f *.o STAR STARstatic STARlong Depend.list

.PHONY: CLEAN
CLEAN:
	rm -f *.o STAR Depend.list
	$(MAKE) -C htslib clean

.PHONY: cleanRelease
cleanRelease:
	rm -f *.o Depend.list
	$(MAKE) -C htslib clean

ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),cleanRelease)
ifneq ($(MAKECMDGOALS),CLEAN)
ifneq ($(MAKECMDGOALS),STARforMac)
ifneq ($(MAKECMDGOALS),STARforMacGDB)
Depend.list: $(SOURCES) parametersDefault.xxd htslib
	echo $(SOURCES)
	'rm' -f ./Depend.list
	$(CXX) $(CXXFLAGS_common) -MM $^ >> Depend.list
include Depend.list
endif
endif
endif
endif
endif

htslib : htslib/libhts.a

htslib/libhts.a :
	$(MAKE) -C htslib lib-static

parametersDefault.xxd: parametersDefault
	xxd -i parametersDefault > parametersDefault.xxd

STAR : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) $(CXXFLAGS)
STAR : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_shared) $(LDFLAGS)
STAR : Depend.list parametersDefault.xxd $(OBJECTS)
	$(CXX) -o STAR $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)

POSIXSHARED : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) -DPOSIX_SHARED_MEM $(CXXFLAGS)
POSIXSHARED : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_shared) $(LDFLAGS)
POSIXSHARED : Depend.list parametersDefault.xxd $(OBJECTS)
	$(CXX) -o STAR $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)

STARstatic : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) $(CXXFLAGS)
STARstatic : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_static) $(LDFLAGS)
STARstatic : Depend.list parametersDefault.xxd $(OBJECTS)
	$(CXX) -o STAR $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)

STARlong : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) -D'COMPILE_FOR_LONG_READS' $(CXXFLAGS)
STARlong : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_shared) $(LDFLAGS)
STARlong : Depend.list parametersDefault.xxd $(OBJECTS)
	$(CXX) -o STARlong $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)

STARlongStatic : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) -D'COMPILE_FOR_LONG_READS' $(CXXFLAGS)
STARlongStatic : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_static) $(LDFLAGS)
STARlongStatic : Depend.list parametersDefault.xxd $(OBJECTS)
	$(CXX) -o STARlong $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)

gdb : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_gdb) $(CXXFLAGS)
gdb : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_gdb) $(LDFLAGS)
gdb : Depend.list parametersDefault.xxd $(OBJECTS)
	$(CXX) -o STAR $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)

gdb-long : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_gdb) -D'COMPILE_FOR_LONG_READS' $(CXXFLAGS)
gdb-long : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_gdb) $(LDFLAGS)
gdb-long : Depend.list parametersDefault.xxd $(OBJECTS)
	$(CXX) -o STARlong $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)

STARforMacStatic : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) -D'COMPILE_FOR_MAC' $(CXXFLAGS)
STARforMacStatic : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_Mac_static) $(LDFLAGS)
STARforMacStatic : Depend.list parametersDefault.xxd $(OBJECTS)
	$(CXX) -o STAR $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)

STARlongForMacStatic : CXXFLAGS := -D'COMPILE_FOR_LONG_READS' $(CXXFLAGSextra) $(CXXFLAGS_main) -D'COMPILE_FOR_MAC' $(CXXFLAGS)
STARlongForMacStatic : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_Mac_static) $(LDFLAGS)
STARlongForMacStatic : Depend.list parametersDefault.xxd $(OBJECTS)
	$(CXX) -o STARlong $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)

=== debian/changelog ===
rna-star (2.7.3a+dfsg-1build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:56:29 +0100

rna-star (2.7.3a+dfsg-1build1) focal; urgency=medium

  * No-change upload for libhts soname change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 31 Jan 2020 22:43:27 +0100

rna-star (2.7.3a+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Bump Standards-Version.
  * Use debhelper 12.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 10 Oct 2019 00:26:31 +0200

rna-star (2.7.2b+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Steffen Moeller <moeller@debian.org>  Thu, 26 Sep 2019 18:51:51 +0200

=== debian/control ===
Source: rna-star
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Andreas Tille <tille@debian.org>,
           Sascha Steinbiss <satta@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12),
               libhts-dev,
               vim-common,
               xxd,
               zlib1g-dev
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/med-team/rna-star
Vcs-Git: https://salsa.debian.org/med-team/rna-star.git
Homepage: https://github.com/alexdobin/STAR/

Package: rna-star
Architecture: amd64 arm64 ppc64el mips64el
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: ultrafast universal RNA-seq aligner
 Spliced Transcripts Alignment to a Reference (STAR) software based on a
 previously undescribed RNA-seq alignment algorithm that uses sequential
 maximum mappable seed search in uncompressed suffix arrays followed by
 seed clustering and stitching procedure. STAR outperforms other aligners
 by a factor of >50 in mapping speed, aligning to the human genome 550
 million 2 × 76 bp paired-end reads per hour on a modest 12-core server,
 while at the same time improving alignment sensitivity and precision. In
 addition to unbiased de novo detection of canonical junctions, STAR can
 discover non-canonical splices and chimeric (fusion) transcripts, and is
 also capable of mapping full-length RNA sequences. Using Roche 454
 sequencing of reverse transcription polymerase chain reaction amplicons,
 the authors experimentally validated 1960 novel intergenic splice
 junctions with an 80-90% success rate, corroborating the high precision
 of the STAR mapping strategy.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#DPKG_EXPORT_BUILDFLAGS = 1
#include /usr/share/dpkg/buildflags.mk

export CCFLAGS=-flto $(CXXFLAGS) $(CPPFLAGS) -std=c++0x
# export LDFLAGS+=-flto -pthread -lhts -lz
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build --sourcedirectory=source -- CCFLAGS_common_add="-flto $(CCFLAGS)" CCFLAGS="$(CCFLAGS)" LDFLAGS_add="$(LDFLAGS)"

override_dh_auto_clean:
	cd source && $(MAKE) clean
	rm -f source/parametersDefault.xxd

override_dh_compress:
	dh_compress --exclude=.pdf

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	debian/tests/run_test.sh $(CURDIR)/source/STAR
endif

=== debian/watch ===
version=3

# Versions ending with a letter are patches, not early releases
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/alexdobin/STAR/releases .*/archive/(?:STAR_?)?(\d[\d.a-z]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## rna-star 2.7.5c+dfsg

=== source/Makefile ===
--- 
+++ 
@@ -13,28 +13,36 @@
 
 # pre-defined flags
 LDFLAGS_shared := -pthread -Lhtslib -Bstatic -lhts -Bdynamic -lz
-LDFLAGS_static := -static -static-libgcc -pthread -Lhtslib -lhts -lz 
+LDFLAGS_static := -static -static-libgcc -pthread -Lhtslib -lhts -lz
 LDFLAGS_Mac :=-pthread -lz htslib/libhts.a
 LDFLAGS_Mac_static :=-pthread -lz -static-libgcc htslib/libhts.a
 LDFLAGS_gdb := $(LDFLAGS_shared)
 
 COMPTIMEPLACE := -D'COMPILATION_TIME_PLACE="$(shell echo `date` $(HOSTNAME):`pwd`)"'
 
-CXXFLAGS_common := -pipe -std=c++11 -Wall -Wextra -fopenmp $(COMPTIMEPLACE)
+# Defaults, can be overridden by make arguments or environment
+CXXFLAGS ?= -pipe -Wall -Wextra
+CFLAGS ?= -pipe -Wall -Wextra -O3
+
+# Unconditionally set essential flags and optimization options
+CXXFLAGS_common := -std=c++11 -fopenmp $(COMPTIMEPLACE)
 CXXFLAGS_main := -O3 $(CXXFLAGS_common)
-CXXFLAGS_gdb :=  -O0 -g $(CXXFLAGS_common)
-
-CFLAGS := -O3 -pipe -Wall -Wextra $(CFLAGS)
-
+CXXFLAGS_gdb := -O0 -g3 $(CXXFLAGS_common)
 
 ##########################################################################################################
-
-OBJECTS = SoloFeature_sumThreads.o SoloFeature_countVelocyto.o SoloFeature_countCBgeneUMI.o Transcriptome_classifyAlign.o SoloFeature_cellFiltering.o \
-        SoloFeature_statsOutput.o bamSortByCoordinate.o SoloBarcode.o \
-        ParametersSolo.o SoloRead.o SoloRead_record.o \
+OBJECTS = soloInputFeatureUMI.o SoloFeature_countSmartSeq.o SoloFeature_redistributeReadsByCB.o \
+	SoloFeature_quantTranscript.o SoloFeature_sumThreads.o SoloFeature_countVelocyto.o SoloFeature_countCBgeneUMI.o \
+	Transcriptome_classifyAlign.o SoloFeature_cellFiltering.o \
+	SoloFeature_statsOutput.o bamSortByCoordinate.o SoloBarcode.o \
+	ParametersSolo.o SoloRead.o SoloRead_record.o \
 	SoloReadBarcode.o SoloReadBarcode_getCBandUMI.o SoloBarcode_extractBarcode.o \
 	SoloReadFeature.o SoloReadFeature_record.o SoloReadFeature_inputRecords.o \
 	Solo.o SoloFeature.o SoloFeature_collapseUMI.o SoloFeature_outputResults.o SoloFeature_processRecords.o SoloFeature_addBAMtags.o \
+	ReadAlign_transformGenome.o Genome_transformGenome.o Transcript_convertGenomeCigar.o \
+	twoPassRunPass1.o samHeaders.o Genome_genomeLoad.o Genome_genomeOutLoad.o Transcript_transformGenome.o ReadAlign_outputSpliceGraphSAM.o \
+	ReadAlign_mapOneReadSpliceGraph.o SpliceGraph.o SpliceGraph_swScoreSpliced.o SpliceGraph_swTraceBack.o \
+	SpliceGraph_findSuperTr.o sjAlignSplit.o \
+	GTF.o GTF_transcriptGeneSJ.o GTF_superTranscript.o SuperTranscriptome.o \
 	ReadAlign_outputAlignments.o  \
 	ReadAlign.o STAR.o \
 	SharedMemory.o PackedArray.o SuffixArrayFuns.o Parameters.o InOutStreams.o SequenceFuns.o Genome.o Stats.o \
@@ -51,16 +59,17 @@
 	ParametersChimeric_initialize.o ReadAlign_chimericDetection.o ReadAlign_chimericDetectionOld.o ReadAlign_chimericDetectionOldOutput.o\
 	ChimericDetection.o ChimericDetection_chimericDetectionMult.o ReadAlign_chimericDetectionPEmerged.o \
 	ChimericSegment.cpp ChimericAlign.cpp ChimericAlign_chimericJunctionOutput.o ChimericAlign_chimericStitching.o \
-	stitchWindowAligns.o extendAlign.o stitchAlignToTranscript.o alignSmithWaterman.o \
+	stitchWindowAligns.o extendAlign.o stitchAlignToTranscript.o \
 	Genome_genomeGenerate.o genomeParametersWrite.o genomeScanFastaFiles.o genomeSAindex.o \
-	Genome_insertSequences.o insertSeqSA.o funCompareUintAndSuffixes.o funCompareUintAndSuffixesMemcmp.o \
-	TimeFunctions.o ErrorWarning.o loadGTF.o streamFuns.o stringSubstituteAll.o \
+	Genome_insertSequences.o Genome_consensusSequence.o \
+	insertSeqSA.o funCompareUintAndSuffixes.o funCompareUintAndSuffixesMemcmp.o \
+	TimeFunctions.o ErrorWarning.o streamFuns.o stringSubstituteAll.o \
 	Transcriptome.o Transcriptome_quantAlign.o Transcriptome_geneFullAlignOverlap.o \
 	ReadAlign_quantTranscriptome.o Quantifications.o Transcriptome_geneCountsAddAlign.o \
 	sjdbLoadFromFiles.o sjdbLoadFromStream.o sjdbPrepare.o sjdbBuildIndex.o sjdbInsertJunctions.o mapThreadsSpawn.o \
-	Parameters_openReadsFiles.cpp Parameters_closeReadsFiles.cpp Parameters_readSAMheader.o \
+	Parameters_readFilesInit.o Parameters_openReadsFiles.cpp Parameters_closeReadsFiles.cpp Parameters_readSAMheader.o \
 	bam_cat.o serviceFuns.o GlobalVariables.cpp \
-	BAMoutput.o BAMfunctions.o ReadAlign_alignBAM.o BAMbinSortByCoordinate.o signalFromBAM.o bamRemoveDuplicates.o BAMbinSortUnmapped.o 
+	BAMoutput.o BAMfunctions.o ReadAlign_alignBAM.o BAMbinSortByCoordinate.o signalFromBAM.o bamRemoveDuplicates.o BAMbinSortUnmapped.o
 
 SOURCES := $(wildcard *.cpp) $(wildcard *.c)
 
@@ -76,6 +85,10 @@
 .PHONY: clean
 clean:
 	rm -f *.o STAR STARstatic STARlong Depend.list
+
+.PHONY: clean_solo
+clean_solo:
+	rm -f Solo*.o
 
 .PHONY: CLEAN
 CLEAN:
@@ -155,5 +168,3 @@
 STARlongForMacStatic : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_Mac_static) $(LDFLAGS)
 STARlongForMacStatic : Depend.list parametersDefault.xxd $(OBJECTS)
 	$(CXX) -o STARlong $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
-
-

=== debian/changelog ===
rna-star (2.7.5c+dfsg-3) unstable; urgency=medium

  * Source upload to enable testing migration.
  * Confirmed autopkgtest fixed.
    Closes: #970340

 -- Sascha Steinbiss <satta@debian.org>  Wed, 16 Sep 2020 08:56:26 +0200

rna-star (2.7.5c+dfsg-2) unstable; urgency=medium

  * Fix autopkgtest by allowing output to stderr.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 15 Sep 2020 15:45:46 +0200

rna-star (2.7.5c+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Steffen Moeller <moeller@debian.org>  Fri, 21 Aug 2020 21:47:38 +0200

rna-star (2.7.5a+20200629git1552aa0-1) unstable; urgency=medium

  * Upstream kindly fixed the FTBFS reported before

 -- Steffen Moeller <moeller@debian.org>  Tue, 07 Jul 2020 19:09:25 +0200

rna-star (2.7.5a+dfsg-1) UNRELEASED; urgency=medium

  * New upstream version
  * TODO: FTBFS - informed upstream on
    - https://github.com/alexdobin/STAR/pull/956
    - https://github.com/alexdobin/STAR/issues/957

 -- Steffen Moeller <moeller@debian.org>  Sat, 27 Jun 2020 17:10:17 +0200

rna-star (2.7.4a+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Steffen Moeller <moeller@debian.org>  Sat, 06 Jun 2020 20:31:10 +0200

rna-star (2.7.3a+dfsg-2) unstable; urgency=medium

  * Team upload.
  * debhelper-compat 12
  * Otherwise no change build to pick up libhts3

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 17 Dec 2019 16:01:10 +0100

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,16 @@
            Sascha Steinbiss <satta@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 13),
                libhts-dev,
                vim-common,
                xxd,
                zlib1g-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/rna-star
 Vcs-Git: https://salsa.debian.org/med-team/rna-star.git
 Homepage: https://github.com/alexdobin/STAR/
+Rules-Requires-Root: no
 
 Package: rna-star
 Architecture: amd64 arm64 ppc64el mips64el

## rna-star 2.7.8a+dfsg

=== source/Makefile ===
--- 
+++ 
@@ -30,14 +30,15 @@
 CXXFLAGS_gdb := -O0 -g3 $(CXXFLAGS_common)
 
 ##########################################################################################################
-OBJECTS = soloInputFeatureUMI.o SoloFeature_countSmartSeq.o SoloFeature_redistributeReadsByCB.o \
+OBJECTS = SoloFeature_collapseUMI_Graph.o SoloFeature_collapseUMIall.o ParametersClip_initialize.o ClipMate_clip.o ClipCR4.o opal/opal.o ClipMate_clipChunk.o ClipMate_initialize.o \
+	SoloFeature_loadRawMatrix.o SoloFeature_emptyDrops_CR.o soloInputFeatureUMI.o SoloFeature_countSmartSeq.o SoloFeature_redistributeReadsByCB.o \
 	SoloFeature_quantTranscript.o SoloFeature_sumThreads.o SoloFeature_countVelocyto.o SoloFeature_countCBgeneUMI.o \
 	Transcriptome_classifyAlign.o SoloFeature_cellFiltering.o \
 	SoloFeature_statsOutput.o bamSortByCoordinate.o SoloBarcode.o \
 	ParametersSolo.o SoloRead.o SoloRead_record.o \
 	SoloReadBarcode.o SoloReadBarcode_getCBandUMI.o SoloBarcode_extractBarcode.o \
 	SoloReadFeature.o SoloReadFeature_record.o SoloReadFeature_inputRecords.o \
-	Solo.o SoloFeature.o SoloFeature_collapseUMI.o SoloFeature_outputResults.o SoloFeature_processRecords.o SoloFeature_addBAMtags.o \
+	Solo.o SoloFeature.o SoloFeature_outputResults.o SoloFeature_processRecords.o SoloFeature_addBAMtags.o \
 	ReadAlign_transformGenome.o Genome_transformGenome.o Transcript_convertGenomeCigar.o \
 	twoPassRunPass1.o samHeaders.o Genome_genomeLoad.o Genome_genomeOutLoad.o Transcript_transformGenome.o ReadAlign_outputSpliceGraphSAM.o \
 	ReadAlign_mapOneReadSpliceGraph.o SpliceGraph.o SpliceGraph_swScoreSpliced.o SpliceGraph_swTraceBack.o \
@@ -45,7 +46,7 @@
 	GTF.o GTF_transcriptGeneSJ.o GTF_superTranscript.o SuperTranscriptome.o \
 	ReadAlign_outputAlignments.o  \
 	ReadAlign.o STAR.o \
-	SharedMemory.o PackedArray.o SuffixArrayFuns.o Parameters.o InOutStreams.o SequenceFuns.o Genome.o Stats.o \
+	SharedMemory.o PackedArray.o SuffixArrayFuns.o Parameters.o Parameters_samAttributes.o InOutStreams.o SequenceFuns.o Genome.o ParametersGenome.o Stats.o \
 	Transcript.o Transcript_alignScore.o Transcript_generateCigarP.o Chain.o \
 	Transcript_variationAdjust.o Variation.o ReadAlign_waspMap.o \
 	ReadAlign_storeAligns.o ReadAlign_stitchPieces.o ReadAlign_multMapSelect.o ReadAlign_mapOneRead.o readLoad.o \
@@ -58,11 +59,10 @@
 	ReadAlign_peOverlapMergeMap.o ReadAlign_mappedFilter.o \
 	ParametersChimeric_initialize.o ReadAlign_chimericDetection.o ReadAlign_chimericDetectionOld.o ReadAlign_chimericDetectionOldOutput.o\
 	ChimericDetection.o ChimericDetection_chimericDetectionMult.o ReadAlign_chimericDetectionPEmerged.o \
-	ChimericSegment.cpp ChimericAlign.cpp ChimericAlign_chimericJunctionOutput.o ChimericAlign_chimericStitching.o \
 	stitchWindowAligns.o extendAlign.o stitchAlignToTranscript.o \
+	ChimericSegment.cpp ChimericAlign.cpp ChimericAlign_chimericJunctionOutput.o ChimericAlign_chimericBAMoutput.o ChimericAlign_chimericStitching.o \
 	Genome_genomeGenerate.o genomeParametersWrite.o genomeScanFastaFiles.o genomeSAindex.o \
-	Genome_insertSequences.o Genome_consensusSequence.o \
-	insertSeqSA.o funCompareUintAndSuffixes.o funCompareUintAndSuffixesMemcmp.o \
+	Genome_insertSequences.o insertSeqSA.o funCompareUintAndSuffixes.o funCompareUintAndSuffixesMemcmp.o \
 	TimeFunctions.o ErrorWarning.o streamFuns.o stringSubstituteAll.o \
 	Transcriptome.o Transcriptome_quantAlign.o Transcriptome_geneFullAlignOverlap.o \
 	ReadAlign_quantTranscriptome.o Quantifications.o Transcriptome_geneCountsAddAlign.o \
@@ -81,6 +81,10 @@
 	$(CXX) -c $(CPPFLAGS) $(CFLAGS) $<
 
 all: STAR
+
+opal/opal.o : opal/opal.cpp opal/opal.h
+	cd opal && \
+	$(CXX) -c -O3 -std=c++11 -march=native opal.cpp
 
 .PHONY: clean
 clean:

=== debian/changelog ===
rna-star (2.7.8a+dfsg-2) unstable; urgency=high

  * Team upload.

  [ Nilesh Patra ]
  * debian/{rules,control,patches/simde.patch}: use libsimde-dev to enable
    building on non-x86 systems.
    Removed "-march=native" architecture baseline violation. Closes: #983723

  [ Michael R. Crusoe ]
  * debian/{rules,clean: specify the source directory, and simplify
  * debian/patches/reproducible.patch: Reproducibly include the build
    time using SOURCE_DATE_EPOCH. Also forwarded upstream
  * On amd64: build STAR for each SIMD level from AVX2 on down.
  * Build and ship STARlong as well

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 01 Mar 2021 20:14:32 +0100

rna-star (2.7.8a+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Upstream did not remove opal/opal.o after build - extended cleaning

 -- Steffen Moeller <moeller@debian.org>  Tue, 23 Feb 2021 19:15:39 +0100

rna-star (2.7.7a+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * Switch watch version to 4

 -- Nilesh Patra <npatra974@gmail.com>  Wed, 06 Jan 2021 16:28:02 +0530

rna-star (2.7.6a+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Fri, 02 Oct 2020 14:49:32 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,17 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Steffen Moeller <moeller@debian.org>,
            Andreas Tille <tille@debian.org>,
-           Sascha Steinbiss <satta@debian.org>
+           Sascha Steinbiss <satta@debian.org>,
+           Nilesh Patra <nilesh@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                libhts-dev,
                vim-common,
                xxd,
-               zlib1g-dev
-Standards-Version: 4.5.0
+               zlib1g-dev,
+               libsimde-dev
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/rna-star
 Vcs-Git: https://salsa.debian.org/med-team/rna-star.git
 Homepage: https://github.com/alexdobin/STAR/
@@ -20,6 +22,7 @@
 Architecture: amd64 arm64 ppc64el mips64el
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Built-Using: ${simde:Built-Using}
 Description: ultrafast universal RNA-seq aligner
  Spliced Transcripts Alignment to a Reference (STAR) software based on a
  previously undescribed RNA-seq alignment algorithm that uses sequential

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export CCFLAGS=-flto $(CXXFLAGS) $(CPPFLAGS) -std=c++0x
# export LDFLAGS+=-flto -pthread -lhts -lz
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

AMD64_SIMD_LEVELS=avx2 avx sse4.1 ssse3 sse3
binprefix=$(CURDIR)/debian/$(DEB_SOURCE)/usr/bin
libexecdir=$(CURDIR)/debian/$(DEB_SOURCE)/usr/lib/$(DEB_SOURCE)/bin
export DEB_CFLAGS_MAINT_APPEND+=-O3
export DEB_CXXFLAGS_MAINT_APPEND+=-O3
# package already builds with -fopenmp, so no need to add that for SIMDe

%:
	dh $@ --sourcedirectory=source

override_dh_auto_build:
ifeq ($(DEB_HOST_ARCH),amd64)
	mkdir --parents $(libexecdir)
	$(foreach SIMD,$(AMD64_SIMD_LEVELS),dh_auto_build -- SFX=-$(SIMD) CCFLAGS_common_add="-flto $(CCFLAGS)" CXXFLAGS="$(CXXFLAGS) -m$(SIMD)" LDFLAGS_add="$(LDFLAGS)" STAR-$(SIMD) STARlong-$(SIMD) && ) true
	dh_auto_build -- SFX=-plain CCFLAGS_common_add="-flto $(CCFLAGS)" CCFLAGS="$(CCFLAGS)" LDFLAGS_add="$(LDFLAGS)" STAR-plain STARlong-plain
	cp source/STAR-plain source/STARlong-plain $(libexecdir)/
else
	dh_auto_build -- CCFLAGS_common_add="-flto $(CCFLAGS)" CCFLAGS="$(CCFLAGS)" LDFLAGS_add="$(LDFLAGS)" STAR STARlong
endif

override_dh_auto_install:
ifeq ($(DEB_HOST_ARCH),amd64)
	mkdir --parents $(binprefix)
	$(foreach SIMD,$(AMD64_SIMD_LEVELS) plain,dh_install source/STAR-$(SIMD) source/STARlong-$(SIMD) /usr/lib/$(DEB_SOURCE)/bin && ) true
	dh_install debian/bin/simd-dispatch /usr/lib/$(DEB_SOURCE)/
	set -e && cd $(binprefix) && for prog in STAR STARlong ; do ln -s \
		../lib/$(DEB_SOURCE)/simd-dispatch $${prog} ; done
else
	dh_install source/STAR source/STARlong usr/bin/
endif

override_dh_auto_clean:
	cd source && ${MAKE} clean

override_dh_compress:
	dh_compress --exclude=.pdf

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifeq ($(DEB_HOST_ARCH),amd64)
	set -i; for SIMD in $(AMD64_SIMD_LEVELS) ; do \
		if lscpu | grep -q $${SIMD} ; then \
		debian/tests/run_test.sh $(CURDIR)/source/STAR-$${SIMD} ; \
		fi ; done
	debian/tests/run_test.sh $(libexecdir)/STAR-plain
else
	debian/tests/run_test.sh $(CURDIR)/source/STAR
endif
endif

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

=== debian/tests/control ===
Test-Command: debian/tests/run_test.sh STAR
Depends: @
Restrictions: allow-stderr

=== debian/watch ===
--- 
+++ 
@@ -1,4 +1,4 @@
-version=3
+version=4
 
 # Versions ending with a letter are patches, not early releases
 opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \

## rna-star 2.7.10a%2Bdfsg

=== debian/changelog ===
rna-star (2.7.10a+dfsg-1) unstable; urgency=medium

  * New upstream version 2.7.10a+dfsg
  * Refresh patches
  * Skip seeking GIT_BRANCH_COMMIT_DIFF

 -- Nilesh Patra <nilesh@debian.org>  Sun, 16 Jan 2022 22:05:44 +0530

rna-star (2.7.9a+dfsg-3) unstable; urgency=medium

  * d/salsa-ci.yml: Reprotest is enabled, disable blhc and i386 build
  * Clean pre-each build so as to build all files for each SIMD level

 -- Nilesh Patra <nilesh@debian.org>  Wed, 18 Aug 2021 15:43:45 +0530

rna-star (2.7.9a+dfsg-2) unstable; urgency=medium

  * d/p/do-not-enforce-avx2.patch: Remove usage of
    -mavx2 by default (Closes: #992270)
  * d/salsa-ci.yml: Disable reprotest and build on i386

 -- Nilesh Patra <nilesh@debian.org>  Wed, 18 Aug 2021 12:20:57 +0530

rna-star (2.7.9a+dfsg-1) unstable; urgency=medium

  [ Steffen Möller ]
  * Update metadata - added ref to guix

  [ Nilesh Patra ]
  * d/watch: Fix watch regex
  * New upstream version 2.7.9a+dfsg
  * Refresh d/p/donotuse_own_htslib.patch
  * Refresh d/p/reproducible.patch
  * Drop d/p/simde.patch: Merged upstream
  * d/salsa-ci.yml: Do not build salsa CI on i386, do not run blhc

 -- Nilesh Patra <nilesh@debian.org>  Sun, 15 Aug 2021 23:18:21 +0530

## rna-star 2.7.10a+dfsg

=== source/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# user may define these whole flags
+# user may define the whole sets of flags
 # LDFLAGS
 # CPPFLAGS
 # CXXFLAGS
@@ -18,22 +18,43 @@
 LDFLAGS_Mac_static :=-pthread -lz -static-libgcc htslib/libhts.a
 LDFLAGS_gdb := $(LDFLAGS_shared)
 
-COMPTIMEPLACE := -D'COMPILATION_TIME_PLACE="$(shell echo `date` $(HOSTNAME):`pwd`)"'
+DATE_FMT = --iso-8601=seconds
+ifdef SOURCE_DATE_EPOCH
+    BUILD_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null || date -u "$(DATE_FMT)")
+else
+    BUILD_DATE ?= $(shell date "$(DATE_FMT)")
+endif
+
+BUILD_PLACE ?= $(HOSTNAME):$(shell pwd)
+
+COMPTIMEPLACE := -D'COMPILATION_TIME_PLACE="$(BUILD_DATE) $(BUILD_PLACE)"'
+
+
+GIT_CHECK := $(shell git status 1> /dev/null 2> /dev/null && echo 0)
+ifeq ($(GIT_CHECK),0)
+	GIT_DIFF := $(shell git diff --name-only | tr '\n' ' ')
+    GIT_BRANCH_COMMIT_DIFF := $(shell git status | head -n 1) ; \
+                                                    $(shell git log | head -n 1) ; \
+                                                    diff files: $(GIT_DIFF)
+endif
+GIT_BRANCH_COMMIT_DIFF := -D'GIT_BRANCH_COMMIT_DIFF="$(GIT_BRANCH_COMMIT_DIFF)"'
 
 # Defaults, can be overridden by make arguments or environment
 CXXFLAGS ?= -pipe -Wall -Wextra
 CFLAGS ?= -pipe -Wall -Wextra -O3
+CXXFLAGS_SIMD ?= -mavx2
 
 # Unconditionally set essential flags and optimization options
-CXXFLAGS_common := -std=c++11 -fopenmp $(COMPTIMEPLACE)
+CXXFLAGS_common := -std=c++11 -fopenmp $(COMPTIMEPLACE) $(GIT_BRANCH_COMMIT_DIFF)
 CXXFLAGS_main := -O3 $(CXXFLAGS_common)
 CXXFLAGS_gdb := -O0 -g3 $(CXXFLAGS_common)
 
 ##########################################################################################################
-OBJECTS = SoloFeature_collapseUMI_Graph.o SoloFeature_collapseUMIall.o ParametersClip_initialize.o ClipMate_clip.o ClipCR4.o opal/opal.o ClipMate_clipChunk.o ClipMate_initialize.o \
+OBJECTS = SoloFeature_collapseUMI_Graph.o SoloFeature_collapseUMIall_multiMappers.o ParametersClip_initialize.o ClipMate_clip.o ClipCR4.o opal/opal.o ClipMate_clipChunk.o ClipMate_initialize.o \
 	SoloFeature_loadRawMatrix.o SoloFeature_emptyDrops_CR.o soloInputFeatureUMI.o SoloFeature_countSmartSeq.o SoloFeature_redistributeReadsByCB.o \
 	SoloFeature_quantTranscript.o SoloFeature_sumThreads.o SoloFeature_countVelocyto.o SoloFeature_countCBgeneUMI.o \
-	Transcriptome_classifyAlign.o SoloFeature_cellFiltering.o \
+	Transcriptome_classifyAlign.o Transcriptome_geneFullAlignOverlap_ExonOverIntron.o Transcriptome_alignExonOverlap.cpp \
+	SoloFeature_cellFiltering.o \
 	SoloFeature_statsOutput.o bamSortByCoordinate.o SoloBarcode.o \
 	ParametersSolo.o SoloRead.o SoloRead_record.o \
 	SoloReadBarcode.o SoloReadBarcode_getCBandUMI.o SoloBarcode_extractBarcode.o \
@@ -80,33 +101,33 @@
 %.o : %.c
 	$(CXX) -c $(CPPFLAGS) $(CFLAGS) $<
 
-all: STAR
+all: cleanCompileInfo STAR$(SFX)
 
 opal/opal.o : opal/opal.cpp opal/opal.h
 	cd opal && \
-	$(CXX) -c -O3 -std=c++11 -march=native opal.cpp
+	$(CXX) -c -I./ -std=c++11 $(CPPFLAGS) $(CXXFLAGS) $(CXXFLAGSextra) $(CXXFLAGS_SIMD) opal.cpp
 
 .PHONY: clean
 clean:
-	rm -f *.o STAR STARstatic STARlong Depend.list
+	'rm' -f *.o opal/opal.o STAR STARstatic STARlong Depend.list parametersDefault.xxd
+
+.PHONY: CLEAN
+CLEAN: clean
+	$(MAKE) -C htslib clean
+
 
 .PHONY: clean_solo
 clean_solo:
-	rm -f Solo*.o
+	'rm' -f Solo*.o
 
-.PHONY: CLEAN
-CLEAN:
-	rm -f *.o STAR Depend.list
-	$(MAKE) -C htslib clean
-
-.PHONY: cleanRelease
-cleanRelease:
-	rm -f *.o Depend.list
-	$(MAKE) -C htslib clean
+.PHONY: cleanCompileInfo
+cleanCompileInfo:
+	'rm' -f STAR.o Parameters.o
 
 ifneq ($(MAKECMDGOALS),clean)
-ifneq ($(MAKECMDGOALS),cleanRelease)
 ifneq ($(MAKECMDGOALS),CLEAN)
+ifneq ($(MAKECMDGOALS),CLEAN)
+ifneq ($(MAKECMDGOALS),clean_solo)
 ifneq ($(MAKECMDGOALS),STARforMac)
 ifneq ($(MAKECMDGOALS),STARforMacGDB)
 Depend.list: $(SOURCES) parametersDefault.xxd htslib
@@ -114,6 +135,7 @@
 	'rm' -f ./Depend.list
 	$(CXX) $(CXXFLAGS_common) -MM $^ >> Depend.list
 include Depend.list
+endif
 endif
 endif
 endif
@@ -128,30 +150,32 @@
 parametersDefault.xxd: parametersDefault
 	xxd -i parametersDefault > parametersDefault.xxd
 
-STAR : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) $(CXXFLAGS)
-STAR : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_shared) $(LDFLAGS)
-STAR : Depend.list parametersDefault.xxd $(OBJECTS)
-	$(CXX) -o STAR $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
+STAR$(SFX) : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) $(CXXFLAGS)
+STAR$(SFX) : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_shared) $(LDFLAGS)
+STAR$(SFX) : Depend.list parametersDefault.xxd $(OBJECTS)
+	$(CXX) -o STAR$(SFX) $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
+
+STARstatic$(SFX) : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) $(CXXFLAGS)
+STARstatic$(SFX) : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_static) $(LDFLAGS)
+STARstatic$(SFX) : Depend.list parametersDefault.xxd $(OBJECTS)
+	$(CXX) -o STAR$(SFX) $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
+
+STARlong$(SFX) : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) -D'COMPILE_FOR_LONG_READS' $(CXXFLAGS)
+STARlong$(SFX) : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_shared) $(LDFLAGS)
+STARlong$(SFX) : Depend.list parametersDefault.xxd $(OBJECTS)
+	$(CXX) -o STARlong$(SFX) $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
+
+STARlongStatic$(SFX) : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) -D'COMPILE_FOR_LONG_READS' $(CXXFLAGS)
+STARlongStatic$(SFX) : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_static) $(LDFLAGS)
+STARlongStatic$(SFX) : Depend.list parametersDefault.xxd $(OBJECTS)
+	$(CXX) -o STARlong$(SFX) $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
+
+
 
 POSIXSHARED : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) -DPOSIX_SHARED_MEM $(CXXFLAGS)
 POSIXSHARED : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_shared) $(LDFLAGS)
 POSIXSHARED : Depend.list parametersDefault.xxd $(OBJECTS)
-	$(CXX) -o STAR $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
-
-STARstatic : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) $(CXXFLAGS)
-STARstatic : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_static) $(LDFLAGS)
-STARstatic : Depend.list parametersDefault.xxd $(OBJECTS)
-	$(CXX) -o STAR $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
-
-STARlong : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) -D'COMPILE_FOR_LONG_READS' $(CXXFLAGS)
-STARlong : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_shared) $(LDFLAGS)
-STARlong : Depend.list parametersDefault.xxd $(OBJECTS)
-	$(CXX) -o STARlong $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
-
-STARlongStatic : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_main) -D'COMPILE_FOR_LONG_READS' $(CXXFLAGS)
-STARlongStatic : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_static) $(LDFLAGS)
-STARlongStatic : Depend.list parametersDefault.xxd $(OBJECTS)
-	$(CXX) -o STARlong $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
+	$(CXX) -o STAR$(SFX) $(CXXFLAGS) $(OBJECTS) $(LDFLAGS)
 
 gdb : CXXFLAGS := $(CXXFLAGSextra) $(CXXFLAGS_gdb) $(CXXFLAGS)
 gdb : LDFLAGS := $(LDFLAGSextra) $(LDFLAGS_gdb) $(LDFLAGS)

=== debian/changelog ===
rna-star (2.7.10a+dfsg-3) unstable; urgency=medium

  * Add patch to fix gcc-12 FTBFS (Closes: #1013030)

 -- Nilesh Patra <nilesh@debian.org>  Fri, 24 Jun 2022 19:46:55 +0000

rna-star (2.7.10a+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Lance Lin ]
  * Remove build-depends on vim-common (Closes: #1007987)

  [ Andreas Tille ]
  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)
  * DEP3

 -- Lance Lin <LQi254@protonmail.com>  Wed, 6 Apr 2022 19:19:25 +0700

=== debian/control ===
--- 
+++ 
@@ -8,11 +8,10 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                libhts-dev,
-               vim-common,
                xxd,
                zlib1g-dev,
                libsimde-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/rna-star
 Vcs-Git: https://salsa.debian.org/med-team/rna-star.git
 Homepage: https://github.com/alexdobin/STAR/

=== debian/watch ===
version=4

# Versions ending with a letter are patches, not early releases
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/alexdobin/STAR/releases .*/.*/(?:STAR_?)?(\d[\d.a-z]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## rna-star 2.7.10b+dfsg

=== source/Makefile ===
--- 
+++ 
@@ -50,7 +50,8 @@
 CXXFLAGS_gdb := -O0 -g3 $(CXXFLAGS_common)
 
 ##########################################################################################################
-OBJECTS = SoloFeature_collapseUMI_Graph.o SoloFeature_collapseUMIall_multiMappers.o ParametersClip_initialize.o ClipMate_clip.o ClipCR4.o opal/opal.o ClipMate_clipChunk.o ClipMate_initialize.o \
+OBJECTS = systemFunctions.o \
+	SoloFeature_collapseUMI_Graph.o SoloFeature_collapseUMIall.o ParametersClip_initialize.o ClipMate_clip.o ClipCR4.o opal/opal.o ClipMate_clipChunk.o ClipMate_initialize.o \
 	SoloFeature_loadRawMatrix.o SoloFeature_emptyDrops_CR.o soloInputFeatureUMI.o SoloFeature_countSmartSeq.o SoloFeature_redistributeReadsByCB.o \
 	SoloFeature_quantTranscript.o SoloFeature_sumThreads.o SoloFeature_countVelocyto.o SoloFeature_countCBgeneUMI.o \
 	Transcriptome_classifyAlign.o Transcriptome_geneFullAlignOverlap_ExonOverIntron.o Transcriptome_alignExonOverlap.cpp \

=== debian/changelog ===
rna-star (2.7.10b+dfsg-2) unstable; urgency=medium

  * Team upload.
  * debian/patches/packaged_simde: Use packaged SIMDe header, not the
    code-copy.
  * Standards-Version: 4.6.2 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 22 Jan 2023 15:33:29 +0100

rna-star (2.7.10b+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 27 Dec 2022 02:18:32 +0100

rna-star (2.7.10a+dfsg-4) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 12 Oct 2022 07:41:46 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Uploaders: Steffen Moeller <moeller@debian.org>,
            Andreas Tille <tille@debian.org>,
            Sascha Steinbiss <satta@debian.org>,
-           Nilesh Patra <nilesh@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -11,7 +10,7 @@
                xxd,
                zlib1g-dev,
                libsimde-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/rna-star
 Vcs-Git: https://salsa.debian.org/med-team/rna-star.git
 Homepage: https://github.com/alexdobin/STAR/

=== debian/rules ===
--- 
+++ 
@@ -23,8 +23,8 @@
 override_dh_auto_build:
 ifeq ($(DEB_HOST_ARCH),amd64)
 	mkdir --parents $(libexecdir)
-	$(foreach SIMD,$(AMD64_SIMD_LEVELS),dh_auto_build -- SFX=-$(SIMD) CCFLAGS_common_add="-flto $(CCFLAGS)" CXXFLAGS="$(CXXFLAGS) -m$(SIMD)" LDFLAGS_add="$(LDFLAGS)" STAR-$(SIMD) STARlong-$(SIMD) && ) true
-	dh_auto_build -- SFX=-plain CCFLAGS_common_add="-flto $(CCFLAGS)" CCFLAGS="$(CCFLAGS)" LDFLAGS_add="$(LDFLAGS)" STAR-plain STARlong-plain
+	$(foreach SIMD,$(AMD64_SIMD_LEVELS),dh_auto_clean ; dh_auto_build -- SFX=-$(SIMD) CCFLAGS_common_add="-flto $(CCFLAGS)" CXXFLAGS="$(CXXFLAGS) -m$(SIMD)" LDFLAGS_add="$(LDFLAGS)" STAR-$(SIMD) STARlong-$(SIMD) && ) true
+	dh_auto_clean ; dh_auto_build -- SFX=-plain CCFLAGS_common_add="-flto $(CCFLAGS)" CCFLAGS="$(CCFLAGS)" LDFLAGS_add="$(LDFLAGS)" STAR-plain STARlong-plain
 	cp source/STAR-plain source/STARlong-plain $(libexecdir)/
 else
 	dh_auto_build -- CCFLAGS_common_add="-flto $(CCFLAGS)" CCFLAGS="$(CCFLAGS)" LDFLAGS_add="$(LDFLAGS)" STAR STARlong

## rna-star 2.7.11b+dfsg

=== source/Makefile ===
--- 
+++ 
@@ -50,7 +50,7 @@
 CXXFLAGS_gdb := -O0 -g3 $(CXXFLAGS_common)
 
 ##########################################################################################################
-OBJECTS = systemFunctions.o \
+OBJECTS = systemFunctions.o funPrimaryAlignMark.o \
 	SoloFeature_collapseUMI_Graph.o SoloFeature_collapseUMIall.o ParametersClip_initialize.o ClipMate_clip.o ClipCR4.o opal/opal.o ClipMate_clipChunk.o ClipMate_initialize.o \
 	SoloFeature_loadRawMatrix.o SoloFeature_emptyDrops_CR.o soloInputFeatureUMI.o SoloFeature_countSmartSeq.o SoloFeature_redistributeReadsByCB.o \
 	SoloFeature_quantTranscript.o SoloFeature_sumThreads.o SoloFeature_countVelocyto.o SoloFeature_countCBgeneUMI.o \

=== debian/changelog ===
rna-star (2.7.11b+dfsg-2) unstable; urgency=medium

  * Team upload.
  * d/control: simplify Aritechture selection via the provisions from
    the architecture-properties package.
  * d/rules: fix typo that was affecting the reprotest when the shell
    was set to Bash.
  * d/rules: fix dh_auto_clean.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 25 Oct 2024 16:34:57 +0200

rna-star (2.7.11b+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * d/rules: Remove override_dh_auto_clean
  * d/clean: Remove generated files (Closes: #1045634)
  * d/patches: Add patch to fix typos

 -- Lance Lin <lq27267@gmail.com>  Fri, 09 Feb 2024 23:04:19 +0700

rna-star (2.7.11a+dfsg-1) unstable; urgency=medium

  [ sangmeng ]
  * debian/control: add loong64 support

  [ Andreas Tille ]
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Mon, 21 Aug 2023 19:46:04 +0200

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,8 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
+               architecture-is-little-endian,
                libhts-dev,
                xxd,
                zlib1g-dev,
@@ -17,7 +19,7 @@
 Rules-Requires-Root: no
 
 Package: rna-star
-Architecture: amd64 arm64 ppc64el mips64el
+Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Built-Using: ${simde:Built-Using}

=== debian/rules ===
--- 
+++ 
@@ -41,16 +41,13 @@
 	dh_install source/STAR source/STARlong usr/bin/
 endif
 
-override_dh_auto_clean:
-	cd source && ${MAKE} clean
-
 override_dh_compress:
 	dh_compress --exclude=.pdf
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 ifeq ($(DEB_HOST_ARCH),amd64)
-	set -i; for SIMD in $(AMD64_SIMD_LEVELS) ; do \
+	set -e; for SIMD in $(AMD64_SIMD_LEVELS) ; do \
 		if lscpu | grep -q $${SIMD} ; then \
 		debian/tests/run_test.sh $(CURDIR)/source/STAR-$${SIMD} ; \
 		fi ; done
@@ -60,5 +57,8 @@
 endif
 endif
 
+override_dh_auto_clean:
+	cd source; $(MAKE) clean
+
 override_dh_gencontrol:
 	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

=== debian/watch ===
version=4

# Versions ending with a letter are patches, not early releases
opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/alexdobin/STAR/tags .*/.*/(?:STAR_?)?(\d[\d.a-z]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
